// Implement the MyActive class:

#include <config.h>
#include "MyActive.h"
#include <StateMachine.h>

extern void toInactive();

// The canonicals just delegate:

MyActive::MyActive() : Active() {}
MyActive::MyActive(const MyActive& rhs) : Active(rhs) {}
MyActive::~MyActive() {}

MyActive&
MyActive::operator=(const MyActive& rhs) {
  Active::operator=(rhs);
  return *this;
}



/////////////////////////////

/* Leave just invokes our toInactive function and
   delegates the rest of the activities to active:

*/
void
MyActive::Leave(StateMachine& rMachine)
{
  toInactive();
  Active::Leave(rMachine);
}
