// A replacement for the Active state that
// allows us to take some action in skeleton (toInactive()
// as the readout state is transitioning to another state
// where data taking is not occuring (PAUSE or INACTIVE).


#ifndef __MYACTIVE_H
#define __MYACTIVE_H

#ifdef HAVE_STD_NAMESPACE
using namespace std;
#endif
#include <Active.h>

class StateMachine;

//
// We save ourselves a bundle of work by deriving from the existing
// active state.
//
class MyActive : public Active 
{
public:
  // The canonicals taht will be delegated to the base class.

  MyActive();
  MyActive(const MyActive& rhs);
  virtual ~MyActive();
  
  MyActive& operator=(const MyActive& rhs);
private:
  int operator==(const MyActive& rhs);
  int operator!=(const MyActive& rhs);
public:
  // Provide an override for Leave() so that we get control when leaving thestate.

  virtual void Leave(StateMachine& rMachine);
    
};


#endif
